Bug 108030 - UNO command for listing and using applied paragraph styles
Summary: UNO command for listing and using applied paragraph styles
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: LibreOffice (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: All All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: UNO-Command-New Writer-Styles-Paragraph
  Show dependency treegraph
 
Reported: 2017-05-23 15:44 UTC by Thomas Lendo
Modified: 2017-06-29 11:45 UTC (History)
7 users (show)

See Also:
Crash report or crash signature:


Attachments
2-row notebookbar-like proposed styles by MSO Word 2013 (+ extended view with all proposed styles) (68.36 KB, image/png)
2017-05-24 09:59 UTC, Thomas Lendo
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Thomas Lendo 2017-05-23 15:44:18 UTC
As 1) not every document (for example in an organization) need to have the same styles and as 2) people should reuse already applied styles instead of randomly choosing any style when editing an existing document, it would be nice to have a UNO command to list applied styles which could be used in a drop-down list or as a set of toolbar/notebookbar buttons or context menu entries.

A defined maximum should ensure readability and clearness.

This could be inserted for example in the Customize dialog as a single command, taking the space of 5 or 10 toolbar/notebookbar buttons when applied to a bar.

If no applied styles are available (e.g. in an empty file using a template) then 1) in the document defined styles should be listed (styles that are used to format header and footer text; style used for the first line in the document; title style ...) and 2) if space is available then other, by LibO pre-defined, most used styles like H1-H3 can be listed.

This system can be reused for other styles as well.

@Jay: As doing much with styles, what's your opinion? Maybe this idea need some fine-tuning.
Comment 1 Yousuf Philips (jay) (retired) 2017-05-24 01:34:43 UTC
Didnt fully understand what you meant as this sounds exactly like the Paragraph Styles drop down list found in the formatting toolbar.
Comment 2 Thomas Lendo 2017-05-24 07:36:12 UTC
In principle I mean dynamically shown paragraph styles (for example: dynamically shown toolbar buttons for paragraph styles in the Formatting (Styles) toolbar instead of the fix pre-defined ones now).

The Paragraph Styles drop-down list shows this behavior, right. I never use these drop-down lists and nor does anybody of my colleagues. In some documents, the number of shown styles in the drop-down list exceeds 50 entries ...
Comment 3 Thomas Lendo 2017-05-24 09:59:43 UTC
Created attachment 133507 [details]
2-row notebookbar-like proposed styles by MSO Word 2013 (+ extended view with all proposed styles)
Comment 4 Yousuf Philips (jay) (retired) 2017-05-24 18:05:44 UTC
(In reply to Thomas Lendo from comment #2)
> In principle I mean dynamically shown paragraph styles (for example:
> dynamically shown toolbar buttons for paragraph styles in the Formatting
> (Styles) toolbar instead of the fix pre-defined ones now).

OK i get what you are talking about.

> The Paragraph Styles drop-down list shows this behavior, right. I never use
> these drop-down lists and nor does anybody of my colleagues. In some
> documents, the number of shown styles in the drop-down list exceeds 50
> entries ...

Well if users have lots of styles in their document, i would expect them to use the styles and formatting sidebar, just like they would use the styles pane in MS Word[1].

[1] https://fud.community.services.support.microsoft.com/Fud/FileDownloadHandler.ashx?fid=94e6523b-293d-47e5-8a56-43457c1427ff

(In reply to Thomas Lendo from comment #3)
> Created attachment 133507 [details]
> 2-row notebookbar-like proposed styles by MSO Word 2013 (+ extended view
> with all proposed styles)

Something like this could be implemented for the notebookbar, though i doubt it would be implemented any time soon, but wouldnt be doable for the toolbar unless it was implemented differently.

@Maxim: So i'm thinking that we could create a group button similar to Outline (.uno:SetOutline) that when opened shows square cropped renderings of the same list found in .uno:StyleApply in a 4x3 grid with a vertical scrollbar (would assume this would need to be a glade widget/control in order for it also to be available in the notebookbar), followed by a 'more style' entry at the bottom that opens up the styles sidebar. Thoughts?
Comment 5 Heiko Tietze 2017-05-26 10:33:44 UTC
(In reply to Yousuf Philips (jay) from comment #4)
> Well if users have lots of styles in their document, i would expect them to
> use the styles and formatting sidebar, just like they would use the styles
> pane in MS Word[1].

Many of the Notebookbar variants are designed for use without the sidebar. 

(In reply to Thomas Lendo from comment #3)
> ...styles by MSO Word 2013 (+ extended view with all proposed styles)

That's not only the applied but also some default styles. 

How about a solution where the style dropdown widget would be enhanced by a filter like in the sidebar? That could be a button next to the dropdown the functions update/new but also a radio button to select what styles to list. Something like

Default
Strong
Emphasis
Cite
-
Paragraph Styles
(o) Character Styles
Applied Styles
Foobar
Comment 6 Yousuf Philips (jay) (retired) 2017-05-26 20:24:23 UTC
(In reply to Heiko Tietze from comment #5)
> Many of the Notebookbar variants are designed for use without the sidebar. 

Yes in general the sidebar isnt intended to be used by many of the Notebookbars, just like when using the standard toolbars, but it will always have features not available elsewhere, like styles & formatting, gallery and navigator, which users will have to use the sidebar to access.

> How about a solution where the style dropdown widget would be enhanced by a
> filter like in the sidebar? That could be a button next to the dropdown the
> functions update/new but also a radio button to select what styles to list.
> Something like

Didnt follow, got a mockup?

(In reply to Thomas Lendo from comment #2)
> The Paragraph Styles drop-down list shows this behavior, right. I never use
> these drop-down lists and nor does anybody of my colleagues. In some
> documents, the number of shown styles in the drop-down list exceeds 50
> entries ...

Thinking about this more, if i wanted to reapply a style already in use in the document to another paragraph, i would simply type the name in the drop down list rather than opening it up.

@Cor, @Regina: What do style die-heart users do when they deal with documents with alot of styles?
Comment 7 Heiko Tietze 2017-05-28 09:32:48 UTC
(In reply to Yousuf Philips (jay) from comment #6)
> > How about a solution where the style dropdown widget would be enhanced by a
> > filter like in the sidebar? ...
> 
> Didnt follow, got a mockup?

"Mockup" is under my comment 5. It's a bad idea. Changing the menu violates the HIG. -> no-value
Comment 8 Thomas Lendo 2017-06-29 11:45:08 UTC
Proposal from Stuart in bug 102915 comment 50 to implement this also in the "Styles" context menu.